<template>
  <a ref="score_button"
    @click="click_score"
    role="button"
    id="score-button"
    tabindex="0"
    data-bs-html="true"
    data-bs-toggle="popover"
    data-bs-trigger="click"
    data-bs-placement="bottom"
    :data-bs-content="similar_articles"><slot></slot></a>
</template>

<script>
import { Popover } from 'bootstrap'
import helper from '../helper'

export default {
  name: 'ScorePopover',
  mixins: [helper],
  props: {
    journal: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      popover: null,
      popover_observer: null,
      popover_dom: null
    }
  },
  mounted () {
    this.create_popover()
  },
  updated () {
    // recreate otherwise an old popover is sometimes shown
    this.create_popover()
  },
  beforeUnmount () {
    // destroy so that it is not visible any more after clicking on other pages
    this.popover.dispose()
    this.popover_observer.disconnect()
  },
  computed: {
    similar_articles () {
      let similarHtml = ''
      if (this.journal.score.title.length !== 0) {
        const articles = this.articles_to_links(this.journal.score.title)
        similarHtml += this.$t('resultentry.sem_titles') + ': <ul><li>' + articles.join('</li><li>') + '</li></ul>'
      }
      if (this.journal.score.abstract.length !== 0) {
        const articles = this.articles_to_links(this.journal.score.abstract)
        similarHtml += this.$t('resultentry.sem_abstracts') + ': <ul><li>' + articles.join('</li><li>') + '</li></ul>'
      }
      if (this.journal.score.dois.length !== 0) {
        const articles = this.articles_to_links(this.journal.score.dois)
        similarHtml += this.$t('resultentry.biblio') + ': <ul><li>' + articles.join('</li><li>') + '</li></ul>'
      }
      if (this.journal.score.semantic_score > 0) {
        similarHtml += this.$t('resultentry.sem_nn') + this.score_precision(this.journal.score.semantic_score)
      }
      return similarHtml
    }
  },
  methods: {
    articles_to_links (articles) {
      return articles.map(a => a.doi !== null ? `<a href="https://doi.org/${a.doi}">${a.title}</a>` : a.title)
    },
    click_score (event) {
      // prevent propagation so the "hide popover" handler is not immediately
      // triggered after creation
      event.stopPropagation()
    },
    click_anywhere (event) {
      // hide popover when a click happens anywhere but in the popover
      if (this.popover_dom !== null && !this.popover_dom.contains(event.target)) {
        this.popover.hide()
      }
    },
    create_popover () {
      if (this.popover_observer !== null) {
        // dispose and disconnect in case of update
        this.popover.dispose()
        this.popover_observer.disconnect()
      }

      this.popover = new Popover(
        this.$refs.score_button,
        {
          trigger: 'click',
          content: this.similar_articles,
          title: () => this.$t('resultentry.popover_title')
        }
      )

      // Implement behavior that click outside of popover hides it.
      // This is not natively available in bootstrap. So we listen to attribute
      // change on button to get the ID of the popover. Then we add a click
      // listener on the whole document.
      this.popover_observer = new MutationObserver(mutations => {
        mutations.forEach(mutation => {
          if (mutation.type === 'attributes' && mutation.attributeName === 'aria-describedby') {
            if (this.$refs.score_button.attributes['aria-describedby'] !== undefined) {
              const popoverId = this.$refs.score_button.attributes['aria-describedby'].value
              this.popover_dom = document.getElementById(popoverId)
              document.addEventListener('click', this.click_anywhere)
            } else {
              document.removeEventListener('click', this.click_anywhere)
            }
          }
        })
      })
      this.popover_observer.observe(this.$refs.score_button, { attributes: true })
    }
  }
}
</script>

<style>
.popover {
  max-width: 600pt !important;
}
</style>
